#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "param.h"
#include "myextern.h"

/*
 * Simulates adaptive system using "METHOD I" described in
 * class and in Narandra's book.  The plant, model & filters are...
 * P(s) = 1 / s ( s - 1 )      (open-loop unstable plant)
 * M(s) = 1 / ( s + 1 ) ^ 2
 * LAMBDA = -2
 */

main()
{

	double         x[N], u[M];
	double         T_max, SamplePeriod, t = 0.0;
	int            k, skip = 10;
	FILE           *fp;
	double		yp, ym, e1, e2, epsilon1;
	double		t0, t1, t2, t3, w0, w1, w2, w3, k1;

	GetData(&T_max, &SamplePeriod, &skip, x, u);
	fp = fopen("data1.m", "w");
	fprintf(fp, "data=[");
	printf("Please stand by ");

	while (t <= T_max) {
	printf(".");

		for (k = 1; k <= skip; k++) {
			yp = x[0];
			ym = x[2];

			w0 = u[1];
			w1 = x[4];
			w2 = yp;
			w3 = x[5];

			t0 = x[6];
			t1 = x[7];
			t2 = x[8];
			t3 = x[9];
			k1 = x[10];

			e1 = yp - ym;
			e2 = t0 * x[11] + t1 * x[13] + t2 * x[15] + t3 * x[17] - x[19];
			epsilon1 = e1 + k1 * e2;

/*
 * u[1] = r(t) is the reference input.  Choose one of the following
 * by uncommenting.
 */

			u[1] = sin(1.0 * t);
/* 

			if ( t < 5.0){
				u[1] = 0.0;
			} else {
				u[1] = 1.0;
			}
 
 */ 
/*
	 		u[1] = sin(t) +  sin(5.0 * t) +  sin(9.0 * t);
 */ 

 
/* The true control input is u[0] = theta * w ... */

			u[0] = t0 * w0 + t1 * w1 + t2 * w2 + t3 * w3;

/* Finally, compute the next state... */

			Runge2(u, SamplePeriod, x);
			t += SamplePeriod;

		}

 /* Print out what is saved to the data file... */

	fprintf(fp, "%5.3f %12.8f %12.8f %12.8f %12.8f %12.8f %12.8f %12.8f %12.8f %12.8f %12.8f\n",
	t, yp, ym, t0, t1, t2, t3, k1, e1, e2, epsilon1 );



	}

	printf(" done.\n");
	fprintf(fp, "]; \n");
	fclose(fp);
	return(0);

}
